searchData={"items":[{"type":"module","title":"AshRandomParams","doc":"","ref":"AshRandomParams.html"},{"type":"macro","title":"AshRandomParams.random_params/1","doc":"","ref":"AshRandomParams.html#random_params/1"},{"type":"module","title":"AshRandomParams.DefaultRandom","doc":"","ref":"AshRandomParams.DefaultRandom.html"},{"type":"function","title":"AshRandomParams.DefaultRandom.random/3","doc":"Callback implementation for  AshRandomParams.Random.random/3 .","ref":"AshRandomParams.DefaultRandom.html#random/3"},{"type":"module","title":"AshRandomParams.Info","doc":"","ref":"AshRandomParams.Info.html"},{"type":"function","title":"AshRandomParams.Info.random_params_options/1","doc":"random_params DSL options\n\nReturns a map containing the and any configured or default values.","ref":"AshRandomParams.Info.html#random_params_options/1"},{"type":"function","title":"AshRandomParams.Info.random_params_random/1","doc":"random attribute, argument generation function","ref":"AshRandomParams.Info.html#random_params_random/1"},{"type":"function","title":"AshRandomParams.Info.random_params_random!/1","doc":"random attribute, argument generation function","ref":"AshRandomParams.Info.html#random_params_random!/1"},{"type":"behaviour","title":"AshRandomParams.Random","doc":"","ref":"AshRandomParams.Random.html"},{"type":"callback","title":"AshRandomParams.Random.random/3","doc":"","ref":"AshRandomParams.Random.html#c:random/3"},{"type":"module","title":"AshRandomParams.Transformer","doc":"","ref":"AshRandomParams.Transformer.html"},{"type":"function","title":"AshRandomParams.Transformer.add_random_attr/1","doc":"","ref":"AshRandomParams.Transformer.html#add_random_attr/1"},{"type":"function","title":"AshRandomParams.Transformer.add_random_params/1","doc":"","ref":"AshRandomParams.Transformer.html#add_random_params/1"},{"type":"function","title":"AshRandomParams.Transformer.after?/1","doc":"Callback implementation for  Spark.Dsl.Transformer.after?/1 .","ref":"AshRandomParams.Transformer.html#after?/1"},{"type":"function","title":"AshRandomParams.Transformer.after_compile?/0","doc":"Callback implementation for  Spark.Dsl.Transformer.after_compile?/0 .","ref":"AshRandomParams.Transformer.html#after_compile?/0"},{"type":"function","title":"AshRandomParams.Transformer.before?/1","doc":"Callback implementation for  Spark.Dsl.Transformer.before?/1 .","ref":"AshRandomParams.Transformer.html#before?/1"},{"type":"function","title":"AshRandomParams.Transformer.do_random_attr/2","doc":"","ref":"AshRandomParams.Transformer.html#do_random_attr/2"},{"type":"function","title":"AshRandomParams.Transformer.do_random_params/2","doc":"","ref":"AshRandomParams.Transformer.html#do_random_params/2"},{"type":"function","title":"AshRandomParams.Transformer.transform/1","doc":"Callback implementation for  Spark.Dsl.Transformer.transform/1 .","ref":"AshRandomParams.Transformer.html#transform/1"},{"type":"extras","title":"AshRandomParams","doc":"# AshRandomParams\n\nA library that generates random parameters for Ash resource actions. It provides a convenient way to create random test data for your Ash resources by automatically generating random values for accepts and arguments.","ref":"readme.html"},{"type":"extras","title":"Usage - AshRandomParams","doc":"Add the `random_params` DSL to your Ash resource:\n\n```elixir\ndefmodule Post do\n  use Ash.Resource, extensions: [AshRandomParams]\n\n  attributes do\n    uuid_primary_key :id\n    attribute :author, :string, allow_nil?: false\n    attribute :title, :string, allow_nil?: false\n    attribute :content, :string, allow_nil?: true\n    attribute :tag, :string, allow_nil?: false, default: \"JS\"\n  end\n\n  random_params do\n    random MyRandom  # Optional: specify your custom random generator\n  end\nend\n```","ref":"readme.html#usage"},{"type":"extras","title":"Using Random Params - AshRandomParams","doc":"```elixir\n# Basic usage\nPost.random_params!(:create)\n=> %{author: \"author-81491\", title: \"title-388112\", content: nil, tag: \"JS\"}\n\n# With initial params\nPost.random_params!(:create, %{author: \"James\"})\n=> %{author: \"James\", title: \"title-388112\", content: nil, tag: \"JS\"}\n\n# With options\nPost.random_params!(:create, %{author: \"James\"}, %{\n  populate: [:content],   \n  omit: [:title],   \n  include_defaults?: false\n})\n=> %{author: \"James\", content: \"content-38128\"}\n```","ref":"readme.html#using-random-params"},{"type":"extras","title":"Default Behavior - AshRandomParams","doc":"By default, it generates random values for accepts and arguments that have `allow_nil?: false` and no default value (`default == nil`). In the example above, `author` and `title` fall into this category.","ref":"readme.html#default-behavior"},{"type":"extras","title":"Belongs To Relationships - AshRandomParams","doc":"For accepts and arguments that match the `name` or `source_attribute` of a `belongs_to` relationship:\n- In `create` actions, they are generated with `nil` values\n- In other actions, they are not generated at all\n\nThis behavior exists because:\n- In `create` actions, omitting a value is equivalent to setting it to `nil`\n- In `update` actions, omitting a value preserves the existing relationship, while explicitly setting it to `nil` removes the relationship","ref":"readme.html#belongs-to-relationships"},{"type":"extras","title":"Options - AshRandomParams","doc":"- `populate`: Forces generation of random values for specified accepts/arguments, overriding the default behavior\n- `omit`: Prevents generation of random values for specified accepts/arguments, overriding the default behavior\n- `include_defaults?`: When set to `true`, includes default values for accepts/arguments that have either `allow_nil?: true` or a non-nil default value. Defaults to `true`. In the example above, this would add `%{content: nil, tag: \"JS\"}` to the generated params.","ref":"readme.html#options"},{"type":"extras","title":"Custom Random Generator - AshRandomParams","doc":"You can implement a custom random generator by using the `AshRandomParams.Random` behaviour:\n\n```elixir\ndefmodule MyRandom do\n  use AshRandomParams.Random\n\n  @impl AshRandomParams.Random\n  def random(%{type: Ash.Type.Integer}, _opts, _context) do\n    777\n  end\n\n  @impl AshRandomParams.Random\n  def random(attr_or_arg, opts, context) do\n    # Fallback to DefaultRandom for all other types\n    AshRandomParams.DefaultRandom.random(attr_or_arg, opts, context)\n  end\nend\n```","ref":"readme.html#custom-random-generator"},{"type":"extras","title":"Features - AshRandomParams","doc":"- Automatically generates random values for action accepts and arguments\n- Supports custom random value generators\n- Useful for testing and development","ref":"readme.html#features"},{"type":"extras","title":"Installation - AshRandomParams","doc":"Add `ash_random_params` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:ash_random_params, \"~> 0.1.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"License - AshRandomParams","doc":"MIT","ref":"readme.html#license"},{"type":"extras","title":"Links - AshRandomParams","doc":"- [GitHub Repository](https://github.com/devall-org/ash_random_params)","ref":"readme.html#links"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.1"}}